
-- A dynamically generated popup menu that returns the selected item
fn DynamicPopupMenu menuItems pos:undefined useRollout:undefined align:#align_topleft =
(
	global __dynamic_popup_menu_selection__ = undefined
	
	local menuString = "rcmenu propertyMenu (\n"
	local index = 1
	for item in menuItems do
	(
		-- Append menu item as a string
		menuString += " menuItem mnu" + (index as String) + " \"" + item + "\"\n"
		-- Append event handler as a string
		menuString += " on mnu" + (index as String) +
			" picked do ( __dynamic_popup_menu_selection__ = \"" + item + "\" )\n"
		index += 1
	)
	menuString += ")\n"
	
	local menu = execute menuString
	
	if pos == undefined then
		pos = mouse.screenpos
	
	if useRollout != undefined then
		PopupMenu menu pos:pos rollout:useRollout align:align
	else
		PopupMenu menu pos:pos align:align
	
	-- Added pump windows messages.
	-- This forces the popup menu message before returning this function.
	CheckMAXMessages()
	
	local res = __dynamic_popup_menu_selection__
	__dynamic_popup_menu_selection__ = undefined
	
	if res != undefined and res.count > 0 then
		return res
	return undefined
)
